#r "System.Windows.Forms"
#r "Microsoft.VisualBasic"

using System.Windows.Forms;
using Microsoft.VisualBasic;
using System.Resources;

string resxPath = Path.Combine(Path.GetDirectoryName(ScriptFilePath), Application.Settings.LanguageCode == "ja" ? "Resources.ja.resx" : "Resources.resx");
ResXResourceSet resx = new ResXResourceSet(resxPath);

var doc = Application.ActiveDocument;

// IĂ}`擾
var selectedShapes = doc.SelectionManager.SelectedShapes;

// I𐔂`FbN
if(selectedShapes.Count <= 0)
{
    MessageBox.Show(resx.GetString("SelectShapeMessage"));
    return;
}

string attributeName = resx.GetString("InputName");

// 
attributeName = Interaction.InputBox(resx.GetString("InputNameMessage"), resx.GetString("InputNameDialogTitle"), attributeName);

if(string.IsNullOrEmpty(attributeName))
    return;

// I𐔂`FbN
if(selectedShapes.Count > 5000)
{
    if(MessageBox.Show(resx.GetString("ConfirmMessage1") + attributeName + resx.GetString("ConfirmMessage2"), "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
        return;
}
else
{
    if(MessageBox.Show(resx.GetString("ConfirmMessage1")+ attributeName + resx.GetString("ConfirmMessage3"), "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
        return;
}

// UNDO Jn
doc.UndoManager.BeginUndoUnit();

int deleteCount = 0;
// 폜
foreach(SelectedShape selectedShape in selectedShapes)
{
    if(selectedShape.Shape.Attributes.Count > 0)
    {
        // RNV
        ShapeAttributeCollection attributes;
        
        // }ȉꍇ
        if(selectedShape.Shape is DrawComponentShape)
        {
            DrawComponentShape drawComponentShape = (DrawComponentShape)selectedShape.Shape;
            attributes = drawComponentShape.Master.Attributes;
            
            if(attributes[attributeName] != null)
            {
                if(MessageBox.Show(attributeName + resx.GetString("DrawComponentConfirm1")+ drawComponentShape.Master.Name + resx.GetString("DrawComponentConfirm2"), "", MessageBoxButtons.YesNo) == DialogResult.No)
                    continue;
            }
            
        }
        else
        {
            attributes = selectedShape.Shape.Attributes;
        }

        // w肵̑擾
        var attribute = attributes[attributeName];

        if(attribute != null)
        {
			// 폜
            attributes.Remove(attribute);
            deleteCount++;
        }
    }
}

// UNDO I
doc.UndoManager.EndUndoUnit();

// 폜bZ[W\
MessageBox.Show(deleteCount.ToString() + resx.GetString("DeleteMessage"));
