#r "System.Windows.Forms"

using System.Windows.Forms;
using System.Resources;

string resxPath = Path.Combine(Path.GetDirectoryName(ScriptFilePath), Application.Settings.LanguageCode == "ja" ? "Resources.ja.resx" : "Resources.resx");
ResXResourceSet resx = new ResXResourceSet(resxPath);

// ݂̐}ʂ擾
var doc = Application.ActiveDocument;

// IĂ}`擾
var selectedShapes = doc.SelectionManager.SelectedShapes;

// I𐔂`FbN
if(selectedShapes.Count <= 0)
{
    MessageBox.Show(resx.GetString("SelectShapeMessage"));
    return;
}

// I𐔂`FbN
if(selectedShapes.Count > 5000)
{
    if(MessageBox.Show(resx.GetString("ConfirmMessageAll1"), "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
        return;
}
else
{
    if(MessageBox.Show(resx.GetString("ConfirmMessageAll2"), "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
        return;
}

// UNDO Jn
doc.UndoManager.BeginUndoUnit();

int deleteCount = 0;
// ׂč폜
foreach(SelectedShape selectedShape in selectedShapes)
{
    if(selectedShape.Shape.Attributes.Count > 0)
    {
        // RNV
        ShapeAttributeCollection attributes;

        // }ȉꍇ
        if(selectedShape.Shape is DrawComponentShape)
        {
            DrawComponentShape drawComponentShape = (DrawComponentShape)selectedShape.Shape;
            attributes = drawComponentShape.Master.Attributes;
            
            if(MessageBox.Show(resx.GetString("DrawComponentConfirmAll1")+ drawComponentShape.Master.Name + resx.GetString("DrawComponentConfirmAll2"), "", MessageBoxButtons.YesNo) == DialogResult.No)
                continue;
        }
        else
        {
            attributes = selectedShape.Shape.Attributes;
        }

        // ׂĂ̑폜
        attributes.Clear();
        deleteCount++;
    }
}
// UNDO I
doc.UndoManager.EndUndoUnit();

// 폜bZ[W\
MessageBox.Show(deleteCount.ToString() + resx.GetString("DeleteMessage"));
